#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

#define endl			'\n'

int h, w;
int n, m;
string s[2111];
int cnt[2111][2111];

int getCnt( int x1, int y1, int x2, int y2 ) {
	int ans = cnt[x2][y2];
	if( x1 )
		ans -= cnt[x1-1][y2];
	if( y1 )
		ans -= cnt[x2][y1-1];
	if( x1 && y1 )
		ans += cnt[x1-1][y1-1];
	return ans;
}

long long getSumXY( int xl, int xr, int yl, int yr ) {
	bool okXL = ( xl % n == 0 );
	bool okXR = ( ( xr + 1 ) % n == 0 );
	bool okYL = ( yl % m == 0 );
	bool okYR = ( ( yr + 1 ) % m == 0 );
	int N = ( xr - xl + 1 ) / n;
	int M = ( yr - yl + 1 ) / m;
	xl %= n;
	xr %= n;
	yl %= m;
	yr %= m;
	if( okXL && okXR && okYL && okYR )
		return 1LL * N * M * getCnt( xl, yl, xr, yr );
	if( okXL && okXR )
		return 1LL * N * getCnt( xl, yl, xr, yr );
	if( okYL && okYR )
		return 1LL * M * getCnt( xl, yl, xr, yr );
	return getCnt( xl, yl, xr, yr );
}

long long getSumY( int xl, int xr, int yl, int yr, int y1, int y2 ) {
	if( y1 > y2 )
		return 0;
	if( yl == y1 && yr == y2 )
		return getSumXY( xl, xr, yl, yr );
	int mid = ( yl + yr ) >> 1;
	return 	getSumY( xl, xr, yl, mid, y1, min( y2, mid ) ) +
			getSumY( xl, xr, mid+1, yr, max( y1, mid+1 ), y2 );
}

long long getSumX( int xl, int xr, int yl, int yr, int x1, int x2, int y1, int y2 ) {
	if( x1 > x2 )
		return 0;
	if( xl == x1 && xr == x2 )
		return getSumY( xl, xr, yl, yr, y1, y2 );
	int mid = ( xl + xr ) >> 1;
	return 	getSumX( xl, mid, yl, yr, x1, min( x2, mid ), y1, y2 ) +
			getSumX( mid+1, xr, yl, yr, max( x1, mid+1 ), x2, y1, y2 );
}

long long solve( int x1, int y1, int x2, int y2 ) {
	return getSumX( 0, h-1, 0, w-1, x1, x2, y1, y2 );
}

int main( int argc, char *argv[] ) {
	cin.tie( 0 ); cin.sync_with_stdio( 0 );
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );
	cin >> h >> w;
	cin >> n >> m;
	for( int i = 0; i < n; i ++ ) {
		cin >> s[i];
		string c = s[i];
		reverse( c.begin(), c.end() );
		s[i] += c;
	}
	for( int i = 0, j = 2 * n - 1; i < n; i ++, j -- ) {
		s[j] = s[i];
	}
	n *= 2;
	m *= 2;
	cnt[0][0] = ( s[0][0] == 'X' );
	for( int i = 1; i < n; i ++ ) {
		cnt[i][0] = cnt[i-1][0] + ( s[i][0] == 'X' );
	}
	for( int j = 1; j < m; j ++ ) {
		cnt[0][j] = cnt[0][j-1] + ( s[0][j] == 'X' );
	}
	for( int i = 1; i < n; i ++ ) {
		for( int j = 1; j < m; j ++ ) {
			cnt[i][j] = cnt[i-1][j] + cnt[i][j-1] - cnt[i-1][j-1] + ( s[i][j] == 'X' );
		}
	}
	int q;
	cin >> q;
	for( int i = 0; i < q; i ++ ) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		x1 --, y1 --, x2 --, y2 --;
		long long ans = solve( x1, y1, x2, y2 );
		cout << ans << endl;
	}
	return 0;
}
